/**
 * Rekursive Addition und Multiplikation.
 * 
 * @author Owyn
 * @version 2008-05-31
 */
public class Numbers {
    
    /**
     * Addiert zwei Zahlen rekursiv.
     * 
     * @param a Erste Zahl
     * @param b Zweite Zahl
     * @return Summe von a und b
     */
    public static int add(int a, int b) {
        if (b == 0) return a;
        // Damit die Addition auch mit negativen Summanden funktioniert:
        // if (b < 0) return add(a - 1, b + 1);
        return add(a + 1, b - 1);
    }
    
    /**
     * Multipliziert zwei Zahlen rekursiv.
     * 
     * @param a Erste Zahl
     * @param b Zweite Zahl
     * @return Produkt von a und b
     */
    public static int mult(int a, int b) {
        if (a == 0 || b == 0) return 0;
        // Damit die Multiplikation auch mit negativen Faktoren funktioniert:
        // if (b < 0) return mult(-a, -b);
        return add(a, mult(a, b - 1));
    }
    
}
